local Class = require('lib.hump.class')

Box = Class{}

function Box:init(world, x, y, w, h)
   self.world = world
   self.posX = x
   self.posY = y
   self.w = w
   self.h = h

   self.world:addCollisionClass('Box')

   self.collider = world:newRectangleCollider(self.posX, self.posY, self.w, self.h, {body_type = 'dynamic'})
end

function Box:update(dt)
   self.posX, self.posY = self.collider.body:getPosition()
end

function Box:draw()
   love.graphics.setColor(255, 0, 255)
   love.graphics.rectangle('fill', self.posX-(self.w/2), self.posY-(self.h/2), self.w, self.h)
   love.graphics.setColor(255, 255, 255)
end

return Box