local HXDX   = require('lib.hxdx')
local Gamera = require('lib.gamera.gamera')

Game = {}

local State = Game


function State:init()
   local Player   = require('class.entities.player')
   local Ground   = require('class.entities.ground')
   local Platform = require('class.entities.platform')
   local Box      = require('class.entities.box')

   world = HXDX.newWorld({gravity_y = 2000})

   cam = Gamera.new(0, 0, 1600, 600)
   cam:setScale(1.5)

   ground = Ground(world, 0, 500, 1600, 50)
   wallLeft = Ground(world, 0, 0, 50, 600)
   wallRight = Ground(world, 1550, 0, 50, 600)
   ceiling = Ground(world, 0, 0, 1600, 50)
   platform = Platform(world, 350, 400, 100, 20)
   player = Player(world, 390, 450, 28, 32)
   box = Box(world, 370, 60, 60, 60)
end

function State:leave()

end

function State:update(dt)
   world:update(dt)

   player:update(dt)
   box:update(dt)

   cam:setPosition(player:getCenter())
end

function State:draw()
   cam:draw(function(l,t,w,h)
         -- Draws the World, drawing all colliders, joints and world queries (for debugging purposes)
         --world:draw()

         ground:draw()
         wallLeft:draw()
         wallRight:draw()
         ceiling:draw()
         platform:draw()
         player:draw()
         box:draw()
      end)
end

function State:keypressed(key)
   player:keypressed(key)
end

function State:keyreleased(key)
end


return State